void cb_quit(Fl_Widget* w, void* v)
{
	main_win->hide();
}

void cb_arrow(Fl_Widget *w, void *v)
{
	long int r;
	r=(long int)v;
	switch(r){
		case ARR_LEFT: main_win->view->Aktzeit-=main_win->view->Zoom/4; break;
		case ARR_RIGHT: main_win->view->Aktzeit+=main_win->view->Zoom/4; break;
		case ARR_UP: main_win->view->offset+=main_win->view->Scale/10; break;
		case ARR_DOWN: main_win->view->offset-=main_win->view->Scale/10; break;
		case ARR_ZOOMIN: main_win->view->Zoom/=2; break;
		case ARR_ZOOMOUT: main_win->view->Zoom*=2; break;
	}
	main_win->redraw();
}


/**********************************************************************/

void cb_print(Fl_Widget* w, void* v){
	char statusText[2000];
	int pw,ph;
	myView *vi;
	myCanvas *canvas;
	Fl_Printer *printer;
	printer=new Fl_Printer();
	printer->start_job(0);
	printer->start_page();
	printer->scale(1);
	printer->printable_rect(&pw,&ph);
	sprintf(statusText,"Seitenformat %d mal %d Pixel",pw,ph);
	statusOut(statusText);
	canvas=new myCanvas(0,0,pw,ph);
	vi=(myView*) malloc(sizeof(myView));
	*vi=*(myView*)(main_win->canvas->user_data());
	canvas->user_data(vi);
	canvas->size(pw,ph);
	canvas->redraw();
	printer->print_widget(canvas,0,0);
	printer->end_page();
	printer->end_job();
}

void cb_ps(Fl_Widget* w, void* v){
#ifndef WIN32
	int pw,ph;
	double r;
	char statusText[2000],*cp;
	FILE *file;
	myView *vi;
	myCanvas *canvas;
	Fl_PostScript_File_Device *printer;

	cp=fl_file_chooser(gettext("select destination file"),"*.ps",main_win->view->PsFileName,0);
	if(!cp) return;
	strcpy(main_win->view->PsFileName,cp);
	printer=new Fl_PostScript_File_Device();
	file=fopen(main_win->view->PsFileName,"w");
	if(!file) return;
	printer->start_job(file,0,Fl_Paged_Device::A4,Fl_Paged_Device::LANDSCAPE);
	printer->start_page();

	r=main_win->view->PsResolution;
	printf("resolution=%lf\n",r);
	r=72/r;
	printf("scale=%lf\n",r);
	printer->scale(r);
	printer->printable_rect(&pw,&ph);
	sprintf(statusText,"Pageformat %d x %d Pixel",pw,ph);
	statusOut(statusText);
	canvas=new myCanvas(0,0,pw,ph);
	vi=(myView*) malloc(sizeof(myView));
	*vi=*(myView*)(main_win->canvas->user_data());
	canvas->user_data(vi);
	canvas->size(pw,ph);
	canvas->redraw();
	printer->print_widget(canvas,0,0);
	printer->end_page();
	printer->end_job();
	free(vi);
#endif
}

void cb_settings(Fl_Widget *w, void *v)
{
	char st1[50];
	int r;
	ui->fontsize->value(main_win->view->sizeFont);
	sprintf(st1,"%6.2lf",main_win->view->Zoom);
	ui->zoom->value(st1);
	sprintf(st1,"%6.2lf",main_win->view->Scale);
	ui->scale->value(st1);
	sprintf(st1,"%d",main_win->view->PsResolution);
	ui->resolution->value(st1);
	if (main_win->view->separator>31 ) sprintf(st1,"%d (%c)",main_win->view->separator,main_win->view->separator);
	else sprintf(st1,"%d",main_win->view->separator);
	ui->separator_char->value(st1);
	sprintf(st1,"%d",main_win->view->Zeitformat);
	ui->time_format->value(st1);
	sprintf(st1,"%d",main_win->view->HeadLines);
	ui->head_lines->value(st1);


	ui->language_file->value(languageFile);
	ui->default_unit->value(main_win->view->DefUnit);
	ui->settings->show();
	ui->settings->position(main_win->x()+20,main_win->y()+20);
	while (ui->settings->visible()) Fl::wait();
	main_win->view->sizeFont=ui->fontsize->value();
	r=sscanf(ui->zoom->value(),"%lf",&main_win->view->Zoom);
	r=sscanf(ui->scale->value(),"%lf",&main_win->view->Scale);
	r=sscanf(ui->time_format->value(),"%d",&main_win->view->Zeitformat);
	if(isdigit(ui->separator_char->value()[0])) r=sscanf(ui->separator_char->value(),"%d",&main_win->view->separator);
	else main_win->view->separator=ui->separator_char->value()[0];
	main_win->size(main_win->w(),main_win->h());
	strcpy(main_win->view->DefUnit,ui->default_unit->value());
	r=atoi(ui->resolution->value());
	if(r) main_win->view->PsResolution=r;
	strcpy(languageFile,ui->language_file->value());
	main_win->view->HeadLines=atoi(ui->head_lines->value());
	main_win->redraw();
}


void cb_fileOpen(Fl_Widget *w, void *v)
{
	char st1[PATH_MAX],*cp;
	strcpy(st1,"");
	cp=fl_file_chooser(gettext("select source file"),"*.csv*",st1,0);
	if(cp) FileOpen(main_win->view,cp);
}

void cb_createStarter(Fl_Widget *w, void *v)
{
#ifndef WIN32
	int r;
	char starterPath[PATH_MAX];
	char appPath[PATH_MAX],*cp;
	char dest[PATH_MAX];
	FILE *f;
	pid_t pid = getpid();
	cp=getenv("HOME");
	if(!cp) return;
	strcpy(starterPath,cp);
	strcat(starterPath,"/.local/share/applications/csvview.desktop");
	r=fl_choice("Create Starter  %s?","Yes","No","?",starterPath);
	if(r==1) return;
	if(r==2){
		return;
	}
	f=fopen(starterPath,"w");
	if(!f) return;
	fprintf(f,"[Desktop Entry]\nVersion=1.0\nEncoding=UTF-8\nName=csv-plotter\nGenericName=csv-plotter\nComment=new CSV plotter\n");
	sprintf(appPath, "/proc/%d/exe", pid);
	if (readlink(appPath, dest, PATH_MAX) == -1) return;
	fprintf(f,"Exec=%s %%f\n",dest);
	if(cp=strrchr(dest,'/')) strcpy(cp,"/images/csvview.xpm");
	fprintf(f,"Icon=%s\n",dest);
	fprintf(f,"Terminal=false\nType=Application\nStartupNotify=false\nName[de]=csv-plotter\nGenericName[de]=csv-plotter\n");
	fprintf(f,"Comment[de]=csv-plotter\nName[de_DE]=csv-plotter\nMimeType=application/csv\n");
	fclose(f);
	r=chmod(starterPath,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
	if(r) fl_alert("chmod error");
#endif
}

void cb_fileClose(Fl_Widget *w, void *v){
	FileClose(main_win->view);
	main_win->redraw();
}

myWindow::myWindow(int w, int h, const char *st): Fl_Window(400,400,w,h,st) {
	view=(myView*)calloc(sizeof(myView),1);
	menu=new Fl_Menu_Bar(0, 0, 400, 20);
	menu->add(gettext("File/&Open"),0,cb_fileOpen);
	menu->add(gettext("File/&Print"), 0, cb_print);
	menu->add(gettext("File/&Write PS"), 0, cb_ps);
	menu->add(gettext("File/&Close"), 0, cb_fileClose);
	menu->add(gettext("File/&Quit"), 0, cb_quit);
	menu->add(gettext("View/Zoom &in"),0,cb_arrow,(void*)ARR_ZOOMIN);
	menu->add(gettext("View/Zoom &out"),0,cb_arrow,(void*)ARR_ZOOMOUT);
	menu->add(gettext("Edit/Settings"),0,cb_settings);
	menu->add(gettext("Extras/Create Starter"),0,cb_createStarter);
	canvas=new myCanvas(0,40,w,h-80);
	canvas->user_data(0);
	xpm_up=new Fl_Pixmap(up_xpm);
	xpm_down=new Fl_Pixmap(down_xpm);
	xpm_left=new Fl_Pixmap(left_xpm);
	xpm_right=new Fl_Pixmap(right_xpm);
	bt_up=new Fl_Button(50,50,20,20);
	bt_up->image(xpm_up);
	bt_up->callback(cb_arrow,(void*)ARR_UP);
	bt_down=new Fl_Button(150,50,20,20);
	bt_down->image(xpm_down);
	bt_down->callback(cb_arrow,(void*)ARR_DOWN);
	bt_left=new Fl_Button(250,50,20,20);
	bt_left->image(xpm_left);
	bt_left->callback(cb_arrow,(void*)ARR_LEFT);
	bt_right=new Fl_Button(350,50,20,20);
	bt_right->image(xpm_right);
	bt_right->callback(cb_arrow,(void*)ARR_RIGHT);
	status=new Fl_Box(0,h-16,w,16);
	status->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
	strcpy(view->windowTitle,"csv-Viewer");
	label(view->windowTitle);
	end();
	status->label(view->statusText);
	}

void myWindow::resize(int x, int y, int w, int h) {
	Fl_Window::resize(x,y,w,h);
	menu->resize(0,0,w,20);
	canvas->resize(0,20,w,h-40);
	status->resize(0,h-16,w,16);
	bt_down->resize(25,view->yPalette-25,20,20);
	bt_left->resize(5,view->yPalette-35,20,20);
	bt_right->resize(45,view->yPalette-35,20,20);
	bt_up->resize(25,view->yPalette-45,20,20);
	}
